//  Author: KOVLEV
//          http://kovlev.boom.ru
//          kovlev@mail.ru
//  Project: Mini-K USB device: I2C/SPI programmer

#include "stdafx.h"
#include "MiniK.h"
#include "MiniKDlg.h"

HANDLE DevHwnd;
int OutputDataLength = 256;
byte OutputData[256];
int OutLength=0; //   USB
  //    
int FNCNumberDoAt24WriteBuffer          =37;	//  
int FNCNumberDoSetTetrade				=40;	// 4   
int FNCNumberDoAt24ReadByte             =33;	// 1 
int FNCNumberDoAt24WriteByte            =38;	// 1 
int FNCNumberDoGetByteFromBuffer        =34;	// 32    
int FNCNumberDoAt24ReadToBuffer         =36;	// 32    

//int NO_ERROR=0;
int DEVICE_NOT_PRESENT=1;

extern LPSTR lpDevName;
extern LPSTR lpProjName;
extern int lpSize;
extern byte DAT[65536];
extern byte DIFF[65536];
extern bool bDif[2048];
extern bool Edited; 

bool OpenDevDriver(void)
{	//    
	bool Result = false;
	HWND Dlg = (HWND) GetActiveWindow();
	DevHwnd = CreateFile(lpDevName, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_WRITE|FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (DevHwnd==INVALID_HANDLE_VALUE) 
	{
		MessageBox(Dlg, "   ", lpProjName, MB_OK);
		goto Ex;
	}
	Result = true;
Ex:;
	return Result;
}

bool CloseDevDriver(void)
{	//    
	bool Result = true;
	if (DevHwnd != INVALID_HANDLE_VALUE) 
		CloseHandle(DevHwnd);
	return Result;
}

bool SendToDriver(byte FunctionNumber, WORD Param1, WORD Param2, byte OutputData[], unsigned long OutLength)
{
	//      
	byte LocalInBuffer[5];
	int RepeatCount;
	int OutLengthMax;
	bool Result= false;
	RepeatCount = 3;
	Result = false;
	if (!OpenDevDriver())
	{
		OutLength = 0;
		goto Ex;
	}
	LocalInBuffer[0] = FunctionNumber;
	LocalInBuffer[1] = LOBYTE(Param1);
	LocalInBuffer[2] = HIBYTE(Param1);
	LocalInBuffer[3] = LOBYTE(Param2);
	LocalInBuffer[4] = HIBYTE(Param2);
	if (OutLength < 0)
		OutLengthMax = OutputDataLength;
	else
		OutLengthMax = OutLength;
	if (OutLengthMax>255)
		OutLengthMax = 255;
	Result = DeviceIoControl(DevHwnd, 0x800 + 8, &LocalInBuffer, 5, OutputData, OutLengthMax, &OutLength, NULL);
	Result = Result & (OutLength > 0);
Ex:;
   CloseDevDriver();
   return Result;
}
/*
void ShowThreadErrorMessage(void)
{
//if some thread locks serialization access - display message
	HWND Dlg = (HWND) GetActiveWindow();
	bool InProgress = false;
	if (InProgress)
		goto Ex;
	InProgress = true;
	MessageBox(Dlg,"   ","",MB_OK);
	InProgress=false;
Ex:;
}
*/
void FillBuff(HWND Dlg)
{	//     
	int i = 0;
	char txt[54] = "Addr: 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F";		//  
	SendDlgItemMessage(Dlg, IDC_DAT, LB_RESETCONTENT, 0, 0);
	int MaxB = lpSize / 16;
	for (i=0;i<MaxB;)
	{
		int adr = i * 16;
		byte adr_h = adr / 256;
		byte adr_l = adr % 256;
		txt[0] = dhex(adr_h / 16);
		txt[1] = dhex(adr_h % 16);
		txt[2] = dhex(adr_l / 16);
		txt[3] = dhex(adr_l % 16);
		txt[4] = 0x3a;
		txt[5] = 0x20;
			txt[6] = dhex(DAT[adr] / 16);
			txt[7] = dhex(DAT[adr] % 16);
			txt[8] = 0x20;
			txt[9] = dhex(DAT[adr + 1] / 16);
			txt[10] = dhex(DAT[adr + 1] % 16);
			txt[11] = 0x20;
			txt[12] = dhex(DAT[adr + 2] / 16);
			txt[13] = dhex(DAT[adr + 2] % 16);
			txt[14] = 0x20;
			txt[15] = dhex(DAT[adr + 3] / 16);
			txt[16] = dhex(DAT[adr + 3] % 16);
			txt[17] = 0x20;
			txt[18] = dhex(DAT[adr + 4] / 16);
			txt[19] = dhex(DAT[adr + 4] % 16);
			txt[20] = 0x20;
			txt[21] = dhex(DAT[adr + 5] / 16);
			txt[22] = dhex(DAT[adr + 5] % 16);
			txt[23] = 0x20;
			txt[24] = dhex(DAT[adr + 6] / 16);
			txt[25] = dhex(DAT[adr + 6] % 16);
			txt[26] = 0x20;
			txt[27] = dhex(DAT[adr + 7] / 16);
			txt[28] = dhex(DAT[adr + 7] % 16);
			txt[29] = 0x20;
			txt[30] = dhex(DAT[adr + 8] / 16);
			txt[31] = dhex(DAT[adr + 8] % 16);
			txt[32] = 0x20;
			txt[33] = dhex(DAT[adr + 9] / 16);
			txt[34] = dhex(DAT[adr + 9] % 16);
			txt[35] = 0x20;
			txt[36] = dhex(DAT[adr + 10] / 16);
			txt[37] = dhex(DAT[adr + 10] % 16);
			txt[38] = 0x20;
			txt[39] = dhex(DAT[adr + 11] / 16);
			txt[40] = dhex(DAT[adr + 11] % 16);
			txt[41] = 0x20;
			txt[42] = dhex(DAT[adr + 12] / 16);
			txt[43] = dhex(DAT[adr + 12] % 16);
			txt[44] = 0x20;
			txt[45] = dhex(DAT[adr + 13] / 16);
			txt[46] = dhex(DAT[adr + 13] % 16);
			txt[47] = 0x20;
			txt[48] = dhex(DAT[adr + 14] / 16);
			txt[49] = dhex(DAT[adr + 14] % 16);
			txt[50] = 0x20;
			txt[51] = dhex(DAT[adr + 15] / 16);
			txt[52] = dhex(DAT[adr + 15] % 16);
			txt[53] = 0x00;
		SendDlgItemMessage(Dlg, IDC_DAT, LB_ADDSTRING, 0, (LPARAM) txt);
		i++;
	}
	RefreshCS(Dlg);
}

void RefreshCS(HWND Dlg)
{	//      ( )
	long c=0, i=0;
	for (i=0; i<lpSize; c += DAT[i], i++) {};
	TCHAR	tszMsg[100];
	_sntprintf(tszMsg, 100, _T(": %x"), c);
	SetDlgItemText(Dlg, IDC_CS, tszMsg);
}

byte ValHex(char V)
{
	byte r=0xff;
	if (V > 0x2f && V < 0x3A)
		r=V-0x30;
	else if (V > 0x40 && V < 0x47)
		r=V-0x37;
	else if (V > 0x60 && V < 0x67)
		r=V-0x57;
	else
		r=0xff;
	return r;
}

unsigned int dhex(unsigned int ddec)
{
//	int HexM[16]={48, 49, 50, 51, 52, 53,  54,  55, 56, 57, 97, 98, 99, 100, 101, 102};  // 
	int HexM[16]={48, 49, 50, 51, 52, 53,  54,  55, 56, 57, 65, 66, 67, 68, 69, 70};	 // 
	return HexM[ddec];
}
//    INT   CHAR *
char lng(int Nu)
{
    char d[10]={'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
    return d[Nu];
}

void LoadToBuffer(void)
{	//   .    ,  FF;   -    .
	HWND Dlg = GetActiveWindow();
	TCHAR szFile[MAX_PATH] = "\0";
	TCHAR szErr[200] = "\0";
	OPENFILENAME* lpofn;
	int i=0, j=0, k=0, ADDR=0;
	DWORD bc=0, d=0;
	HANDLE file=INVALID_HANDLE_VALUE;
	if (Edited)
		if (MessageBox(Dlg, "  .  ?", lpProjName, MB_YESNO) == IDNO)
			goto Ex;
	lpofn=(OPENFILENAME*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY, sizeof(OPENFILENAME));
	lpofn->lpstrTitle = " ";
	lpofn->lStructSize = sizeof(OPENFILENAME);
	lpofn->hwndOwner = Dlg;
	lpofn->hInstance = NULL;
	lpofn->lpstrFilter = " (*.bin)\0*.bin\0  (*.*)\0*.*\0\0";
	lpofn->lpstrCustomFilter = NULL;
	lpofn->nMaxCustFilter = 0;
	lpofn->nFilterIndex = 0;
	lpofn->lpstrInitialDir = NULL;
	lpofn->Flags = OFN_SHOWHELP | OFN_EXPLORER | OFN_HIDEREADONLY;
	lpofn->lpfnHook = NULL;
	lpofn->lpTemplateName = NULL;
	lpofn->lpstrDefExt = NULL;
	lpofn->nFileExtension = 0;
	lpofn->nFileOffset = 0;
	lpofn->nMaxFile = sizeof(szFile);
	lpofn->lpstrFile = szFile;
	lpofn->nMaxFileTitle = 0;
	lpofn->lpstrFileTitle = NULL;
	lpofn->lCustData = NULL;
	GetOpenFileName(lpofn);
	d = CommDlgExtendedError();
	if (d)
		SetDlgItemInt(Dlg, IDC_STATUS, d, false);
	else
		SetDlgItemText(Dlg, IDC_STATUS, szFile);
	if (!strlen(szFile))
		goto L0;

	file=CreateFile(szFile, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	if(file==INVALID_HANDLE_VALUE) 
	{
		MessageBox(Dlg, "  ", lpProjName, MB_OK);
		goto L0;
	}
	ReadFile(file, DAT, lpSize, &bc, NULL);
	for (i=0;i<lpSize;DIFF[i]=DAT[i], i++) {};
	Edited = false;
L0:;
	if (file !=INVALID_HANDLE_VALUE)
		CloseHandle(file);
	HeapFree(GetProcessHeap(), 0, lpofn);
Ex:;
}

void uReadAll()
{	// .    
	TCHAR szFile[MAX_PATH] = "\0";
	TCHAR szErr[200] = "\0";
	HANDLE file=INVALID_HANDLE_VALUE;
	DWORD bc;
	HWND Dlg = (HWND) GetActiveWindow();
	WORD Adr = 0xA0;
	WORD Adress = 0;
	int i=0, j=0;
	int MaxB = lpSize / 32;	//   - 32 
	SendDlgItemMessage(Dlg, IDC_PB, PBM_SETRANGE, 0, (LPARAM) MAKELPARAM (0, MaxB));
	if (Edited)
		if (MessageBox(Dlg, "  .  ?", lpProjName, MB_YESNO) == IDNO)
			goto Ex;
	file=CreateFile("temp.bin", GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
	if(file==INVALID_HANDLE_VALUE) 
	{
		MessageBox(Dlg, "  ",lpProjName,MB_OK);
		goto Ex;
	}
	
	if (IsDlgButtonChecked(Dlg, IDC_A0))
		Adr = Adr | 2;
	if (IsDlgButtonChecked(Dlg, IDC_A1))
		Adr = Adr | 4;

	SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
	OutLength=32;
	for (j=0;j<MaxB;)
	{
		Adress = j*32;
		if (SendToDriver(FNCNumberDoAt24ReadToBuffer,Adress,Adr,OutputData,OutLength))
			for (i=0; i<32;DIFF[Adress+i]=DAT[Adress+i]=OutputData[i],i++) {}
		else
			goto Ex;
		j++;
		SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, j, 0);
	}
	SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, 0, 0);
	WriteFile(file, DAT, lpSize, &bc, NULL);
	Edited = false;
Ex:;
   if (file !=INVALID_HANDLE_VALUE)
		CloseHandle(file);
   SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
}


void SaveBuffer(void)
{
	HWND Dlg = (HWND) GetActiveWindow();
	TCHAR szFile[MAX_PATH] = "\0";
	TCHAR szErr[200] = "\0";
	OPENFILENAME* lpofn;
	DWORD d;
	HANDLE file=INVALID_HANDLE_VALUE;
	DWORD bc;
	lpofn=(OPENFILENAME*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY, sizeof(OPENFILENAME));
	lpofn->lpstrTitle = "   ";
	lpofn->lStructSize = sizeof(OPENFILENAME);
	lpofn->hwndOwner = Dlg;
	lpofn->hInstance = NULL;
	lpofn->lpstrFilter = " (*.bin)\0*.bin\0  (*.*)\0*.*\0\0";
	lpofn->lpstrCustomFilter = NULL;
	lpofn->nMaxCustFilter = 0;
	lpofn->nFilterIndex = 0;
	lpofn->lpstrInitialDir = NULL;
	lpofn->Flags = OFN_SHOWHELP | OFN_EXPLORER | OFN_HIDEREADONLY;
	lpofn->lpfnHook = NULL;
	lpofn->lpTemplateName = NULL;
	lpofn->lpstrDefExt = "bin";
	lpofn->nFileExtension = 0;
	lpofn->nFileOffset = 0;
	lpofn->nMaxFile = sizeof(szFile);
	lpofn->lpstrFile = szFile;
	lpofn->nMaxFileTitle = 0;
	lpofn->lpstrFileTitle = NULL;
	lpofn->lCustData = NULL;
	GetSaveFileName(lpofn);
	d = CommDlgExtendedError();
	if (d)
		SetDlgItemInt(Dlg, IDC_STATUS, d, true);
	else
		SetDlgItemText(Dlg, IDC_STATUS, szFile);
	if (!strlen(szFile))
		goto Ex;

	file = CreateFile(szFile, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
	if(file == INVALID_HANDLE_VALUE) 
	{
		MessageBox(Dlg, "  ", lpProjName, MB_OK);
		goto Ex;
	}
	WriteFile(file, DAT, lpSize, &bc, NULL);
	Edited = false;
	if(file != INVALID_HANDLE_VALUE)
		CloseHandle(file);
Ex:;
}





void uWriteBuffer(void)
{
	TCHAR szFile[MAX_PATH] = "\0";
	TCHAR szErr[200] = "\0";
	HWND Dlg = (HWND) GetActiveWindow();
	WORD Adr = 0xA0;
	WORD Adress = 0;
	WORD Param1=0, Param2=0;
	byte NumByte=0;
	int i=0, j=0, t=0;
	int MaxB = lpSize / 32;	//   - 32 
	if (MessageBox(Dlg, "     ?", lpProjName, MB_YESNO) == IDNO)
		goto Ex;
	SendDlgItemMessage(Dlg, IDC_PB, PBM_SETRANGE, 0, (LPARAM) MAKELPARAM (0, MaxB));

	if (IsDlgButtonChecked(Dlg, IDC_A0))
		Adr = Adr | 2;
	if (IsDlgButtonChecked(Dlg, IDC_A1))
		Adr = Adr | 4;

	SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
	OutLength=1;

	if (IsDlgButtonChecked(Dlg, IDC_FW))
	{
		MakeDiff();
		for (j=0;j<MaxB;)
		{
			if (bDif[j])
			{
				Adress = j*32;
				for (t=0,NumByte=0;NumByte<32;)
				{
					Param1 = DAT[Adress+NumByte] + (DAT[Adress+NumByte+1]<<8);
					Param2 = DAT[Adress+NumByte+2] + (DAT[Adress+NumByte+3]<<8);
					if (!SendToDriver(FNCNumberDoSetTetrade+t,Param1,Param2,OutputData,OutLength))
						goto Ex;
					NumByte +=4;
					t++;
				}
				if (SendToDriver(FNCNumberDoAt24WriteBuffer,Adress,Adr,OutputData,OutLength))
					j++;
				else
					goto Ex;
				SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, j, 0);
			}
			else
			{
				j++;
			}
		}
	}
	else
	{
		for (j=0;j<MaxB;)
		{
			Adress = j*32;
			for (t=0,NumByte=0;NumByte<32;)
			{
				Param1 = DAT[Adress+NumByte] + (DAT[Adress+NumByte+1]<<8);
				Param2 = DAT[Adress+NumByte+2] + (DAT[Adress+NumByte+3]<<8);
				if (!SendToDriver(FNCNumberDoSetTetrade+t,Param1,Param2,OutputData,OutLength))
					goto Ex;
				NumByte +=4;
				t++;
			}
			if (SendToDriver(FNCNumberDoAt24WriteBuffer,Adress,Adr,OutputData,OutLength))
				j++;
			else
				goto Ex;
			SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, j, 0);
		}
	}
Ex:;
		SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, 0, 0);
		Edited = false;
		SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
}

void MakeDiff(void)
{
	int i=0, n=0, a=0, iBlock=lpSize/32;
	memset(&bDif, FALSE, 2048);
	for (i=0;i<iBlock;)
	{
		for(n=0, bDif[i]=false;n<32;)
		{
			a = i*32+n;
			if (DIFF[a]==DAT[a])
			{
				n++;
			}
			else
			{
				bDif[i] = true;
				break;
			}
		}
		i++;
	}
}


void uClearAll(void)
{
	TCHAR szFile[MAX_PATH] = "\0";
	TCHAR szErr[200] = "\0";
	HWND Dlg = (HWND) GetActiveWindow();
	WORD Adr = 0xA0;
	WORD Adress = 0;
	WORD Param1=0, Param2=0;
	byte NumByte=0;
	int i=0, j=0, t=0;
	int MaxB = lpSize / 32;	//   - 32 
	if (MessageBox(Dlg, "   ?", lpProjName, MB_YESNO) == IDNO)
		goto Ex;
	SendDlgItemMessage(Dlg, IDC_PB, PBM_SETRANGE, 0, (LPARAM) MAKELPARAM (0, MaxB));
	if (IsDlgButtonChecked(Dlg, IDC_A0))
		Adr = Adr | 2;
	if (IsDlgButtonChecked(Dlg, IDC_A1))
		Adr = Adr | 4;
	SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
	OutLength=1;
	for (j=0;j<MaxB;)
	{
		Adress = j*32;
		for (t=0,NumByte=0;NumByte<32;)
		{
			Param1 = 0xFFFF;
			Param2 = 0xFFFF;
			if (!SendToDriver(FNCNumberDoSetTetrade+t,Param1,Param2,OutputData,OutLength))
				goto Ex;
			NumByte +=4;
			t++;
		}
		if (SendToDriver(FNCNumberDoAt24WriteBuffer,Adress,Adr,OutputData,OutLength))
			j++;
		else
			goto Ex;
		SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, j, 0);
	}
Ex:;
	SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, 0, 0);
	Edited = false;
	SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
}


void uCompareCS(void)
{
	TCHAR	tszMsg[100];
	byte	BUFF[65536];
	HWND	Dlg = (HWND) GetActiveWindow();
	WORD	Adr = 0xA0;
	WORD	Adress = 0;
	int i=0, j=0;
	int MaxB = lpSize / 32;	//   - 32 
	long c=0, sm=0;
	for (i=0; i<lpSize; c += DAT[i], i++) {};
	SendDlgItemMessage(Dlg, IDC_PB, PBM_SETRANGE, 0, (LPARAM) MAKELPARAM (0, MaxB));
	if (IsDlgButtonChecked(Dlg, IDC_A0))
		Adr = Adr | 2;
	if (IsDlgButtonChecked(Dlg, IDC_A1))
		Adr = Adr | 4;
	SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
	OutLength=32;
	for (j=0;j<MaxB;)
	{
		Adress = j*32;
		if (SendToDriver(FNCNumberDoAt24ReadToBuffer,Adress,Adr,OutputData,OutLength))
			for (i=0; i<32;BUFF[Adress+i]=OutputData[i],i++) {}
		else
			goto Ex;
		j++;
		SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, j, 0);
	}
	SendDlgItemMessage(Dlg,IDC_PB, PBM_SETPOS, 0, 0);
	for (i=0; i<lpSize; sm += BUFF[i], i++) {};
	if (c==sm)
		_sntprintf(tszMsg, 100, _T(" : %x \n : %x %s"), sm, c, _T("\n\nOK !"));
	else
		_sntprintf(tszMsg, 100, _T(" : %x \n : %x %s"), sm, c, _T("\n\n   !"));
	MessageBox(Dlg, tszMsg, lpProjName, MB_OK);
Ex:;
	SetDlgItemText(Dlg, IDC_STATUS, _T(" "));
}

